# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from data_repo_client.configuration import Configuration


class ConfigModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'config_type': 'str',
        'fault': 'ConfigFaultModel',
        'parameter': 'ConfigParameterModel'
    }

    attribute_map = {
        'name': 'name',
        'config_type': 'configType',
        'fault': 'fault',
        'parameter': 'parameter'
    }

    def __init__(self, name=None, config_type=None, fault=None, parameter=None, local_vars_configuration=None):  # noqa: E501
        """ConfigModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._config_type = None
        self._fault = None
        self._parameter = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if config_type is not None:
            self.config_type = config_type
        if fault is not None:
            self.fault = fault
        if parameter is not None:
            self.parameter = parameter

    @property
    def name(self):
        """Gets the name of this ConfigModel.  # noqa: E501

        name of the configuration  # noqa: E501

        :return: The name of this ConfigModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ConfigModel.

        name of the configuration  # noqa: E501

        :param name: The name of this ConfigModel.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def config_type(self):
        """Gets the config_type of this ConfigModel.  # noqa: E501


        :return: The config_type of this ConfigModel.  # noqa: E501
        :rtype: str
        """
        return self._config_type

    @config_type.setter
    def config_type(self, config_type):
        """Sets the config_type of this ConfigModel.


        :param config_type: The config_type of this ConfigModel.  # noqa: E501
        :type: str
        """
        allowed_values = ["fault", "parameter", "logging"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and config_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `config_type` ({0}), must be one of {1}"  # noqa: E501
                .format(config_type, allowed_values)
            )

        self._config_type = config_type

    @property
    def fault(self):
        """Gets the fault of this ConfigModel.  # noqa: E501


        :return: The fault of this ConfigModel.  # noqa: E501
        :rtype: ConfigFaultModel
        """
        return self._fault

    @fault.setter
    def fault(self, fault):
        """Sets the fault of this ConfigModel.


        :param fault: The fault of this ConfigModel.  # noqa: E501
        :type: ConfigFaultModel
        """

        self._fault = fault

    @property
    def parameter(self):
        """Gets the parameter of this ConfigModel.  # noqa: E501


        :return: The parameter of this ConfigModel.  # noqa: E501
        :rtype: ConfigParameterModel
        """
        return self._parameter

    @parameter.setter
    def parameter(self, parameter):
        """Sets the parameter of this ConfigModel.


        :param parameter: The parameter of this ConfigModel.  # noqa: E501
        :type: ConfigParameterModel
        """

        self._parameter = parameter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ConfigModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ConfigModel):
            return True

        return self.to_dict() != other.to_dict()
