# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from data_repo_client.configuration import Configuration


class DirectoryDetailModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'enumerated': 'bool',
        'contents': 'list[FileModel]'
    }

    attribute_map = {
        'enumerated': 'enumerated',
        'contents': 'contents'
    }

    def __init__(self, enumerated=None, contents=None, local_vars_configuration=None):  # noqa: E501
        """DirectoryDetailModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._enumerated = None
        self._contents = None
        self.discriminator = None

        if enumerated is not None:
            self.enumerated = enumerated
        if contents is not None:
            self.contents = contents

    @property
    def enumerated(self):
        """Gets the enumerated of this DirectoryDetailModel.  # noqa: E501

        Indicates whether or not the directory has been enumerated. True means the directory has been enumerated. The contents property describes the contents. An empty array indicates and empty directory. False means the directory has not been enumerated. If the contents property is present, it should be ignored.   # noqa: E501

        :return: The enumerated of this DirectoryDetailModel.  # noqa: E501
        :rtype: bool
        """
        return self._enumerated

    @enumerated.setter
    def enumerated(self, enumerated):
        """Sets the enumerated of this DirectoryDetailModel.

        Indicates whether or not the directory has been enumerated. True means the directory has been enumerated. The contents property describes the contents. An empty array indicates and empty directory. False means the directory has not been enumerated. If the contents property is present, it should be ignored.   # noqa: E501

        :param enumerated: The enumerated of this DirectoryDetailModel.  # noqa: E501
        :type: bool
        """

        self._enumerated = enumerated

    @property
    def contents(self):
        """Gets the contents of this DirectoryDetailModel.  # noqa: E501

        Array of directory contents  # noqa: E501

        :return: The contents of this DirectoryDetailModel.  # noqa: E501
        :rtype: list[FileModel]
        """
        return self._contents

    @contents.setter
    def contents(self, contents):
        """Sets the contents of this DirectoryDetailModel.

        Array of directory contents  # noqa: E501

        :param contents: The contents of this DirectoryDetailModel.  # noqa: E501
        :type: list[FileModel]
        """

        self._contents = contents

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DirectoryDetailModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DirectoryDetailModel):
            return True

        return self.to_dict() != other.to_dict()
