# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from data_repo_client.configuration import Configuration


class DRSContentsObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'id': 'str',
        'drs_uri': 'list[str]',
        'contents': 'list[DRSContentsObject]'
    }

    attribute_map = {
        'name': 'name',
        'id': 'id',
        'drs_uri': 'drs_uri',
        'contents': 'contents'
    }

    def __init__(self, name=None, id=None, drs_uri=None, contents=None, local_vars_configuration=None):  # noqa: E501
        """DRSContentsObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._id = None
        self._drs_uri = None
        self._contents = None
        self.discriminator = None

        self.name = name
        if id is not None:
            self.id = id
        if drs_uri is not None:
            self.drs_uri = drs_uri
        if contents is not None:
            self.contents = contents

    @property
    def name(self):
        """Gets the name of this DRSContentsObject.  # noqa: E501

        A name declared by the bundle author that must be used when materialising this object, overriding any name directly associated with the object itself. The name must be unique with the containing bundle. This string is made up of uppercase and lowercase letters, decimal digits, hypen, period, and underscore [A-Za-z0-9.-_]. See http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap03.html#tag_03_282[portable filenames].  # noqa: E501

        :return: The name of this DRSContentsObject.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DRSContentsObject.

        A name declared by the bundle author that must be used when materialising this object, overriding any name directly associated with the object itself. The name must be unique with the containing bundle. This string is made up of uppercase and lowercase letters, decimal digits, hypen, period, and underscore [A-Za-z0-9.-_]. See http://pubs.opengroup.org/onlinepubs/9699919799/basedefs/V1_chap03.html#tag_03_282[portable filenames].  # noqa: E501

        :param name: The name of this DRSContentsObject.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def id(self):
        """Gets the id of this DRSContentsObject.  # noqa: E501

        A DRS identifier of an `Object` (either a single blob or a nested bundle). If this ContentsObject is an object within a nested bundle, then the id is optional. Otherwise, the id is required.  # noqa: E501

        :return: The id of this DRSContentsObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this DRSContentsObject.

        A DRS identifier of an `Object` (either a single blob or a nested bundle). If this ContentsObject is an object within a nested bundle, then the id is optional. Otherwise, the id is required.  # noqa: E501

        :param id: The id of this DRSContentsObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def drs_uri(self):
        """Gets the drs_uri of this DRSContentsObject.  # noqa: E501

        A list of full DRS identifier URI paths that may be used to obtain the object. These URIs may be external to this DRS instance.  # noqa: E501

        :return: The drs_uri of this DRSContentsObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._drs_uri

    @drs_uri.setter
    def drs_uri(self, drs_uri):
        """Sets the drs_uri of this DRSContentsObject.

        A list of full DRS identifier URI paths that may be used to obtain the object. These URIs may be external to this DRS instance.  # noqa: E501

        :param drs_uri: The drs_uri of this DRSContentsObject.  # noqa: E501
        :type: list[str]
        """

        self._drs_uri = drs_uri

    @property
    def contents(self):
        """Gets the contents of this DRSContentsObject.  # noqa: E501

        If this ContentsObject describes a nested bundle and the caller specified \"?expand=true\" on the request, then this contents array must be present and describe the objects within the nested bundle.  # noqa: E501

        :return: The contents of this DRSContentsObject.  # noqa: E501
        :rtype: list[DRSContentsObject]
        """
        return self._contents

    @contents.setter
    def contents(self, contents):
        """Sets the contents of this DRSContentsObject.

        If this ContentsObject describes a nested bundle and the caller specified \"?expand=true\" on the request, then this contents array must be present and describe the objects within the nested bundle.  # noqa: E501

        :param contents: The contents of this DRSContentsObject.  # noqa: E501
        :type: list[DRSContentsObject]
        """

        self._contents = contents

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DRSContentsObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DRSContentsObject):
            return True

        return self.to_dict() != other.to_dict()
