# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from data_repo_client.configuration import Configuration


class DRSServiceInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'version': 'str',
        'title': 'str',
        'description': 'str',
        'contact': 'object',
        'license': 'object'
    }

    attribute_map = {
        'version': 'version',
        'title': 'title',
        'description': 'description',
        'contact': 'contact',
        'license': 'license'
    }

    def __init__(self, version=None, title=None, description=None, contact=None, license=None, local_vars_configuration=None):  # noqa: E501
        """DRSServiceInfo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._version = None
        self._title = None
        self._description = None
        self._contact = None
        self._license = None
        self.discriminator = None

        self.version = version
        if title is not None:
            self.title = title
        if description is not None:
            self.description = description
        if contact is not None:
            self.contact = contact
        if license is not None:
            self.license = license

    @property
    def version(self):
        """Gets the version of this DRSServiceInfo.  # noqa: E501

        Service version  # noqa: E501

        :return: The version of this DRSServiceInfo.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this DRSServiceInfo.

        Service version  # noqa: E501

        :param version: The version of this DRSServiceInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and version is None:  # noqa: E501
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def title(self):
        """Gets the title of this DRSServiceInfo.  # noqa: E501

        Service name  # noqa: E501

        :return: The title of this DRSServiceInfo.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this DRSServiceInfo.

        Service name  # noqa: E501

        :param title: The title of this DRSServiceInfo.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def description(self):
        """Gets the description of this DRSServiceInfo.  # noqa: E501

        Service description  # noqa: E501

        :return: The description of this DRSServiceInfo.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DRSServiceInfo.

        Service description  # noqa: E501

        :param description: The description of this DRSServiceInfo.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def contact(self):
        """Gets the contact of this DRSServiceInfo.  # noqa: E501

        Maintainer contact info  # noqa: E501

        :return: The contact of this DRSServiceInfo.  # noqa: E501
        :rtype: object
        """
        return self._contact

    @contact.setter
    def contact(self, contact):
        """Sets the contact of this DRSServiceInfo.

        Maintainer contact info  # noqa: E501

        :param contact: The contact of this DRSServiceInfo.  # noqa: E501
        :type: object
        """

        self._contact = contact

    @property
    def license(self):
        """Gets the license of this DRSServiceInfo.  # noqa: E501

        License information for the exposed API  # noqa: E501

        :return: The license of this DRSServiceInfo.  # noqa: E501
        :rtype: object
        """
        return self._license

    @license.setter
    def license(self, license):
        """Sets the license of this DRSServiceInfo.

        License information for the exposed API  # noqa: E501

        :param license: The license of this DRSServiceInfo.  # noqa: E501
        :type: object
        """

        self._license = license

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DRSServiceInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DRSServiceInfo):
            return True

        return self.to_dict() != other.to_dict()
